package nc.pub.filesystem.newui;

import java.awt.event.ActionEvent;
import java.util.ArrayList;

import javax.swing.AbstractAction;
import javax.swing.Action;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.funcnode.ui.action.AbstractNCAction;
import nc.itf.bd.defdoc.IDefdocService;
import nc.itf.th.IThOcrService;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pub.BusinessException;

public class ThSelectAction extends AbstractNCAction{

	private ThFileContentPanel parentpanel;
	private IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	
	public ThSelectAction(ThFileContentPanel para){
		parentpanel = para;
		this.putValue(AbstractAction.NAME,"Ʊȡ");
		this.putValue(Action.SHORT_DESCRIPTION, "Ʊȡ");
	}

	@Override
	public void actionPerformed(ActionEvent actionevent) {
		MessageDialog.showHintDlg(parentpanel, "ʾ","ʼƱȡ");
		String vdef17 =(String) parentpanel.editor_.getBillCardPanel().getHeadItem("vdef17").getValueObject();//id
		String pk_org = (String) parentpanel.editor_.getBillCardPanel().getHeadItem("pk_org").getValueObject();
		String pk_group = (String) parentpanel.editor_.getBillCardPanel().getHeadItem("pk_group").getValueObject();
		String billmaker = InvocationInfoProxy.getInstance().getUserId();
		IThOcrService  ocrservice=(IThOcrService) NCLocator.getInstance().lookup(IThOcrService.class.getName());
		//ȡtoken
		String token="";
		JSONObject json = null;
		try {
			 token=ocrservice.getToken(billmaker);
		} catch (Exception e) {
			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
					,"ȡtoken:\n"+e.getMessage());
			return;
		}
		
		try {
			json = ocrservice.SelectORCInvoice(token);
		} catch (Exception e) {
			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
					,"ȡƱƷƱ:\n"+e.getMessage());
		}
			JSONObject data = json.getJSONObject("data");
			JSONArray infos = data.getJSONArray("infos");
			for(int j = 0;j < infos.size();j++){
				JSONObject info = infos.getJSONObject(j);
				String memo = info.getString("number");//Ʊ
				String code = info.getString("number");//Ʊ
				String fid = info.getString("fid");
				String ext = info.getString("ext");
				JSONObject extobj = JSONObject.parseObject(ext);
				String trate = extobj.getString("trate");//˰
				JSONObject modify_info = info.getJSONObject("modify_info");
				String name = modify_info.getString("fname");
				JSONObject comm_info = info.getJSONObject("comm_info");
				JSONObject pro = comm_info.getJSONObject("pro");
				String date = pro.getString("date");//Ʊ
				String type = pro.getString("type");//Ʊ
				String cname = pro.getString("cname");//Ʊ
				JSONObject price = comm_info.getJSONObject("price");
				String amount = "";
				String total = "";
				String dtax = "";
				//רƱ˰רƱ˰=˰ϼ
				if(type.equals("1")||type.equals("28")||type.equals("32")){
					amount = price.getString("amount");//˰
					total = price.getString("total");//˰ϼ
					dtax = price.getString("dtax");//ɵֿ˰
				}
				else{
					amount = price.getString("total");//˰
					total = amount;//˰ϼ
					dtax = "0";//ɵֿ˰
					trate = "0";//רƱ˰ҲΪ0
				}
				JSONObject buyer = comm_info.getJSONObject("buyer");
				String mnecode = buyer.getString("tcode");//˰ʶ
				String name2 = buyer.getString("company");//򷽹˾
				JSONObject payer = comm_info.getJSONObject("payer");
				String name3 = payer.getString("tcode");//۷˰ʶ
				String name4 = payer.getString("company");//򷽹˾
				
				IDefdocService idefservice = NCLocator.getInstance().lookup(IDefdocService.class);
				
				DefdocVO[] updatevos=QryDefdocvoInfo(code);
				
				if(updatevos.length>0){
					//Զ嵵룬޸
					DefdocVO defvo =updatevos[0];
					//ֵ
					defvo.setAttributeValue("name", memo);
					defvo.setAttributeValue("memo", name);
					defvo.setAttributeValue("mnecode", mnecode);
					defvo.setAttributeValue("name2", name2);
					defvo.setAttributeValue("name3", name3);
					defvo.setAttributeValue("name4", name4);
					defvo.setAttributeValue("name5", fid);
					defvo.setAttributeValue("name6", vdef17);
					defvo.setAttributeValue("shortname", amount);
					defvo.setAttributeValue("shortname2", total);
					defvo.setAttributeValue("shortname3", dtax);
					defvo.setAttributeValue("shortname4", date);
					defvo.setAttributeValue("shortname5", cname);
					defvo.setAttributeValue("shortname6", trate);
					defvo.setAttributeValue("enablestate", 2);
					try {
						idefservice.updateDefdocs(pk_group,updatevos);
					} catch (BusinessException e1) {
						MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
								,"޸Զ嵵:\n"+e1.getMessage());
						return;
					}
				}else{
					DefdocVO[] vos = new DefdocVO[1];
					DefdocVO defvo = new DefdocVO();
					//ֵ
					defvo.setAttributeValue("code", code);
					defvo.setAttributeValue("name", memo);
					defvo.setAttributeValue("memo", name );
					defvo.setAttributeValue("mnecode", mnecode);
					defvo.setAttributeValue("name2", name2);
					defvo.setAttributeValue("name3", name3);
					defvo.setAttributeValue("name4", name4);
					defvo.setAttributeValue("name5", fid);
					defvo.setAttributeValue("name6", vdef17);
					defvo.setAttributeValue("pk_defdoclist", QryOCRPk());
					defvo.setAttributeValue("pk_group", pk_group);
					defvo.setAttributeValue("pk_org", pk_group);
					defvo.setAttributeValue("datatype", 1);
					defvo.setAttributeValue("enablestate", 2);
					defvo.setAttributeValue("shortname", amount);
					defvo.setAttributeValue("shortname2", total);
					defvo.setAttributeValue("shortname3", dtax);
					defvo.setAttributeValue("shortname4", date);
					defvo.setAttributeValue("shortname5", cname);
					defvo.setAttributeValue("shortname6", trate);
					vos[0] = defvo;
					try {
						idefservice.insertDefdocs(pk_group, vos);
					} catch (BusinessException e) {
						// TODO Զɵ catch 
						MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
									,"Զ嵵:\n"+e.getMessage());
						return;
					}
					
					MessageDialog.showHintDlg(parentpanel, "ʾ","ȡɹ");
				}
			}
	}
	
    @SuppressWarnings("unchecked")
	private DefdocVO[]  QryDefdocvoInfo(String code){
        	String sql = "select * from  bd_defdoc where  nvl(dr, 0) = 0 and pk_defdoclist="
        			+ "(select pk_defdoclist from bd_defdoclist where code='OCRTHNC' and nvl(dr,0)=0) and code='" + code + "' ";
        	ArrayList<Object> arrayvos=null;
        	try {
				arrayvos=(ArrayList<Object>) iuap.executeQuery(sql, new BeanListProcessor(DefdocVO.class));
			} catch (BusinessException e) {
				// TODO Զɵ catch 
				e.printStackTrace();
			}
        	
        	if (arrayvos==null||arrayvos.size()==0) {
      			return new DefdocVO[0];
      		}else {
      			return arrayvos.toArray(new DefdocVO[0]);
      		}
        	
        } 
    
    //ѯԶ嵵pk
    private String QryOCRPk(){
    	String sql = "select pk_defdoclist from bd_defdoclist where code='OCRTHNC' and nvl(dr,0)=0";
    	Object object = null;
		try {
			object = iuap.executeQuery(sql, new ColumnProcessor());
		} catch (BusinessException e) {
			// TODO Զɵ catch 
			e.printStackTrace();
		}
		if (object==null) {
			return null;
		}else {
			return object.toString();
		}
    }

}
