package nc.ui.pu.m25.editor.card.afteredit.body;

import nc.itf.scmpub.reference.uap.bd.vat.BuySellFlagEnum;
import nc.itf.scmpub.reference.uap.bd.vat.VATInfoQueryVO;
import nc.itf.scmpub.reference.uap.bd.vat.VATInfoVO;
import nc.ui.pu.m25.editor.utils.RelationCalculate;
import nc.ui.pu.m25.editor.utils.TaxRateAndTypeUtil;
import nc.ui.pu.m25.rule.InvoiceQueryPriceHandler;
import nc.ui.pu.pub.editor.CardEditorHelper;
import nc.ui.pu.pub.editor.card.listener.ICardBodyAfterEditEventListener;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pubapp.uif2app.event.card.CardBodyAfterEditEvent;
import nc.ui.pubapp.uif2app.view.util.RefMoreSelectedUtils;
import nc.vo.pu.m25.entity.InvoiceHeaderVO;
import nc.vo.pu.m25.entity.InvoiceItemVO;
import nc.vo.pu.pub.enumeration.PricePriority;
import nc.vo.pu.pub.rule.vat.BillItemVatTaxInfoSetter;
import nc.vo.pu.pub.rule.vat.TaxValue;
import nc.vo.pu.pub.util.ObjectUtil;
import nc.vo.pu.pub.util.PUSysParamUtil;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pubapp.AppContext;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.pubapp.scale.ScaleUtils;

import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;

/**
 * <p>
 * <b>Ҫ¹ܣ</b>
 * <ul>
 * <li>ϱ༭
 * </ul>
 * <p>
 * <p>
 * 
 * @version 6.0
 * @since 6.0
 * @author tianft
 * @time 2010-3-26 10:38:21
 */
public class Material implements ICardBodyAfterEditEventListener {

  @Override
  public void afterEdit(CardBodyAfterEditEvent event) {

    RefMoreSelectedUtils utils =
        new RefMoreSelectedUtils(event.getBillCardPanel());
    event.getBillCardPanel().getBillModel().setNeedCalculate(false);
    // ѡ
    int[] rows =
        utils.refMoreSelected(event.getRow(), InvoiceItemVO.PK_MATERIAL, true);
    // 
    if (rows.length == 1 && ObjectUtil.isEmptyWithTrim(event.getValue())) {
      event.getBillCardPanel().getBillModel().setNeedCalculate(true);
      return;

    }
    // ϱ༭ʱѾϵ£λܱö
    this.calculateByNum(event.getBillCardPanel(), rows);

    // ---------Զ̵úϲ-------------------------------------
    // ѡ,ѯƻۣ˰
    TaxRateAndTypeUtil util =
        new TaxRateAndTypeUtil(event.getBillCardPanel(), rows);
    util.prepare();
    // ѯԶ̵úϲ
    InvoiceQueryPriceHandler price =
        new InvoiceQueryPriceHandler(event.getBillCardPanel(), rows);
    price.prepareQueryPrice();
    // VATϢùԶ̵
    TaxValue taxvaluerule =
        this.getVatValueRule(event.getBillCardPanel(), rows);
    taxvaluerule.prepare();

    // ---------Զ̵úϲִĴ---------------------
    // VATϢ
    this.setVatVule(taxvaluerule, event.getBillCardPanel(), rows);
    // ƻ
    util.setPlanPrice();
    // ѯۣۿϲѯۣ
    price.handleQueryPrice();
    event.getBillCardPanel().getBillModel().setNeedCalculate(true);
  }

  /**
   * ༭ʱõλ
   * 
   * @param event
   * @param rows
   */
  private void calculateByNum(BillCardPanel panel, int[] rows) {
    if (ArrayUtils.isEmpty(rows)) {
      return;
    }
    ScaleUtils scale = new ScaleUtils(AppContext.getInstance().getPkGroup());
    for (int row : rows) {
      panel.setBodyValueAt(scale.adjustHslScale("1.00/1.00"), row,
          InvoiceItemVO.VCHANGERATE);
    }
    RelationCalculate calc = new RelationCalculate();
    calc.calculate(panel, rows, InvoiceItemVO.NNUM);
  }

  private TaxValue getVatValueRule(BillCardPanel bcp, int[] rows) {
    CardEditorHelper invoice = new CardEditorHelper(bcp);
    String sendcountry =
        invoice.getHeadStringValue(InvoiceHeaderVO.CSENDCOUNTRYID);
    String rececountry =
        invoice.getHeadStringValue(InvoiceHeaderVO.CRECECOUNTRYID);
    String taxcountry =
        invoice.getHeadStringValue(InvoiceHeaderVO.CTAXCOUNTRYID);
    UFDate billdate = invoice.getHeadUFDateValue(InvoiceHeaderVO.DBILLDATE);
    Integer fbsflag =
        (Integer) invoice.getHeadValue(InvoiceHeaderVO.FBUYSELLFLAG);
    String pk_supplier =
        invoice.getHeadStringValue(InvoiceHeaderVO.PK_SUPPLIER);
    UFBoolean triatrade =
        ValueUtils.getUFBoolean(invoice
            .getHeadValue(InvoiceHeaderVO.BTRIATRADEFLAG));
    String pk_org = invoice.getHeadStringValue(InvoiceHeaderVO.PK_ORG);
    VATInfoQueryVO[] vatqvos = new VATInfoQueryVO[rows.length];
    for (int i = 0; i < rows.length; i++) {
      if (StringUtils.isBlank(sendcountry) || StringUtils.isBlank(rececountry)
          || StringUtils.isBlank(taxcountry)
          || StringUtils.isBlank(pk_supplier) || null == billdate
          || null == fbsflag) {
        continue;
      }
      String pk_material =
          invoice.getBodyStringValue(rows[i], InvoiceItemVO.PK_MATERIAL);
      vatqvos[i] =
          new VATInfoQueryVO(taxcountry, BuySellFlagEnum.valueOf(fbsflag),
              triatrade, sendcountry, rececountry, pk_supplier, pk_material,
              billdate, pk_org);
    }
    TaxValue tv = new TaxValue(vatqvos);
    tv.prepare();
    return tv;
  }

  private void setVatVule(TaxValue tv, BillCardPanel bcp, int[] rows) {
    CardEditorHelper invoice = new CardEditorHelper(bcp);
    // VATValueSetProvider puorgbuysellGetter = new
    // VATValueSetProvider(invoice);
    // puorgbuysellGetter.setFbuysellflagPos(PosEnum.head);
    BillItemVatTaxInfoSetter setter = new BillItemVatTaxInfoSetter(invoice);
    RelationCalculate calc = new RelationCalculate();
    tv.process();
    VATInfoVO[] vatinfos = tv.getVatinfos();
    String pk_purchaseorg =
        invoice.getHeadStringValue(InvoiceHeaderVO.PK_PURCHASEORG);
    PricePriority pricePriority =
        PUSysParamUtil.getPO28For25(pk_purchaseorg) ? PricePriority.TAXPRICE_PRIOR_TO_PRICE
            : PricePriority.PRICE_PRIOR_TO_TAXPRICE;
    for (int i = 0; i < rows.length; i++) {
      VATInfoVO vatvo = vatinfos[i];
      if (null == vatvo) {
        continue;
      }
      String chgkey = setter.setVatTax(vatvo, rows[i], pricePriority);
      if (null == chgkey) {
        continue;
      }
      calc.calculate(invoice.getEditor(), new int[] {
        rows[i]
      }, chgkey);
    }
  }

}
